package de.cliffbreak.varo;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import org.bukkit.Difficulty;
import org.bukkit.NamespacedKey;
import org.bukkit.World;
import org.bukkit.World.Environment;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.configuration.file.YamlConfiguration;

import de.cliffbreak.varo.commands.VaroCommand;
import de.cliffbreak.varo.listeners.BannedItemListener;
import de.cliffbreak.varo.listeners.ChatListener;
import de.cliffbreak.varo.listeners.CreatureSpawnListener;
import de.cliffbreak.varo.listeners.EntityRegainHealthListener;
import de.cliffbreak.varo.listeners.PlayerDeathListener;
import de.cliffbreak.varo.listeners.PlayerJoinQuitListener;
import de.cliffbreak.varo.listeners.PlayerPreLoginListener;

public class Varo extends JavaPlugin {

    public File configurationFile = new File("plugins/CliffbreakVaro", "config.yml");
    public FileConfiguration config = YamlConfiguration.loadConfiguration(this.configurationFile);

    @Override
    public void onEnable() {

        getLogger().info("CliffbreakVaro is starting...");

        // this.config.addDefault("Varo.Start", "TODO: StartDate");
        this.config.addDefault("Varo.Bans", new ArrayList<String>());
        this.config.options().copyDefaults(true);
        this.saveConfiguration();

        // this.config.getStringList(path)

        getServer().getPluginManager().registerEvents(new PlayerPreLoginListener(this), this);
        getServer().getPluginManager().registerEvents(new PlayerJoinQuitListener(this), this);
        getServer().getPluginManager().registerEvents(new ChatListener(), this);
        getServer().getPluginManager().registerEvents(new EntityRegainHealthListener(), this);
        getServer().getPluginManager().registerEvents(new PlayerDeathListener(this), this);
        getServer().getPluginManager().registerEvents(new BannedItemListener(), this);
        getServer().getPluginManager().registerEvents(new CreatureSpawnListener(), this);

        getCommand("varo").setExecutor(new VaroCommand(this));

        for (World world : getServer().getWorlds()) {
            if (world.getEnvironment() == Environment.NORMAL) {
                world.setDifficulty(Difficulty.HARD);
            }
        }
        getServer().removeRecipe(NamespacedKey.minecraft("fishing_rod"));
    }

    @Override
    public void onDisable() {
        getLogger().info("Stopping CliffbreakVaro!");
    }

    public void saveConfiguration() {
        try {
            getLogger().info("Saving Config...");
            this.config.save(this.configurationFile);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
