package de.cliffbreak.varo.listeners;

import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityPickupItemEvent;
import org.bukkit.event.inventory.InventoryClickEvent;

public class BannedItemListener implements Listener {

    @EventHandler()
    public void onEntityPickupItem(EntityPickupItemEvent e) {
        if (e.getEntity() instanceof Player) {
            Material mat = e.getItem().getItemStack().getType();
            if (isForbiddenMaterial(mat)) {
                e.getEntity().sendMessage("§cVerbotenes Item wurde entfernt.");
                e.getItem().remove();
                e.setCancelled(true);
            }
        }
    }

    @EventHandler()
    public void onInventoryClick(InventoryClickEvent e) {
        if (e.getCurrentItem() == null)
            return;
        Material mat = e.getCurrentItem().getType();
        if (isForbiddenMaterial(mat)) {
            e.getWhoClicked().sendMessage("§cVerbotenes Item kann nicht ins Inventar verschoben werden.");
            e.setCancelled(true);
        }
    }

    private boolean isForbiddenMaterial(Material mat) {
        return mat.equals(Material.ENCHANTED_GOLDEN_APPLE) || mat.equals(Material.FISHING_ROD)
                || mat.equals(Material.TOTEM_OF_UNDYING);
    }
}