package de.cliffbreak.varo.listeners;

import java.util.Stack;

import com.destroystokyo.paper.event.server.PaperServerListPingEvent;

import org.bukkit.Bukkit;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.event.server.ServerListPingEvent;

import de.cliffbreak.varo.Varo;
import de.cliffbreak.varo.uitls.MessageUtils;

public class PlayerJoinQuitListener implements Listener {

    private final Varo plugin;
    private int task;

    public PlayerJoinQuitListener(final Varo plugin) {
        this.plugin = plugin;
    }

    @EventHandler()
    public void onPlayerQuit(final PlayerQuitEvent e) {
        e.setQuitMessage(null);
        Bukkit.broadcast(
                MessageUtils.getRichTextComponent(e.getPlayer().getName(), "§f hat den Server verlassen.", true));
    }

    @EventHandler()
    public void onPlayerJoin(final PlayerJoinEvent e) {
        e.setJoinMessage(null);
        Bukkit.broadcast(
                MessageUtils.getRichTextComponent(e.getPlayer().getName(), "§f hat den Server betreten.", true));
        e.getPlayer().sendMessage("\n§7§l#### §9Cliffbreak.de - §lVaro §r§9Changelog §7§l####\n \n"
                + "   §cWarning: §r§c Plugin is running in DEBUG mode!\n ");

        final Stack<String> changes = new Stack<String>();

        changes.push(" §7• §r§lFIX: §rCheck for Ban in AsyncPreLoginEvent");
        changes.push(" §7• §r§lFIX: §rOnly kick player after Entity isn't ticking anymore");
        changes.push(" §7• §r§lADD: §r/varo Command for Admins");
        changes.push(" §7• §r§lADD: §rBan Player on Death");
        changes.push(" §7• §r§lADD: §r1.8 Health Regeneration");
        changes.push(" §7• §r§lADD: §rCustom Dynamic ServerListEntry");
        changes.push(" §7• §r§lADD: §rControl Difficulty and Gamerules by the Plugin");
        changes.push(" §7• §r§lADD: §rHover over Playername for Details (Team)");
        changes.push(" §7• §r§lADD: §rRedesigned Chat with Timestamp");

        this.task = Bukkit.getScheduler().scheduleSyncRepeatingTask(plugin, new Runnable() {

            @Override
            public void run() {
                if (!e.getPlayer().isOnline()) {
                    stopScheduler();
                    return;
                }
                if (changes.empty()) {
                    stopScheduler();
                    return;
                }
                e.getPlayer().sendMessage(changes.pop());
            }
        }, 20, 20);
    }

    private void stopScheduler() {
        Bukkit.getScheduler().cancelTask(this.task);
    }

    @EventHandler()
    public void onServerListPing(final ServerListPingEvent event) {
        if (event instanceof PaperServerListPingEvent) {
            handlePaperServerListPing((PaperServerListPingEvent) event);
        } else {
            Bukkit.getLogger().info("Error: Plugin is not running on a PaperServer");
        }
    }

    private void handlePaperServerListPing(final PaperServerListPingEvent e) {
        e.setHidePlayers(true);
        // TODO: Add day counter
        e.setMotd("§9§l" + "VARO" + "§b§l " + "Tag: -1" + "\n§r§7" + "powered by " + "§4" + "Cliffbreak.de");
    }
}